/*global define*/
define([
    'backbone.marionette',
    'sandbox/event',
    './mouse',
    '../templates/views/widgets/widgetitem'
], function (Marionette, vent, Mouse, template) {

    'use strict';

    var mouse = new Mouse();

    return Marionette.ItemView.extend({

        initialize : function () {
            this.$hoveredEl = null;
            this.hightlightEvent = mouse.hightlightEvent;

            this.listenTo(vent, mouse.lastHoveredEvent, this.onHover);
        },

        app: null,

        objectType: '',

        tagName: 'li',

        template: template,

        attributes: {
            'data-view': 'widgetitem'
        },

        events: {
            'dragstart': 'dragStart',
            'dragend': 'dragEnd'
        },

        action: function () {
            return;
        },

        // Overwritable placeholder method
        onHover: function () {
            return;
        },

        addContent: function (data) {
            vent.trigger('editor.content:add', data);
        },

        dragStart: function () {
            return;
        },

        dragEnd: function (event) {
            if (event.originalEvent.dataTransfer.dropEffect !== 'none') {
                this.action();
            }
        }

    });

});
