/*global define*/
define(['sandbox/event', 'sandbox/dom', '../../widgetitem'], function (vent, $, WidgetView) {

    'use strict';

    return WidgetView.extend({

        onHover: function (element, style) {
            var $hoveredEl,
                data;

            // TODO
            // Need to know, if currently **dragging** or just **hovering**
            // If and only if **dragging**
            //
            if (style === 'forbidden' || style === 'droppable') {
                return;
            }

            if (this.$hoveredEl) {
                // Remove edit mode event
                this.$hoveredEl.off('click.' + this.cid);

                // Reset element
                this.$hoveredEl = null;
            }

            // set hovered element and trigger highlight
            if (element) {
                $hoveredEl = $(element);
                data = $hoveredEl.data() || {};

                if (data.view === 'content' && data.type === 'text') {
                    this.$hoveredEl = $hoveredEl;

                    // Bind click event to start edit mode
                    $hoveredEl.on('click.' + this.cid, function () {
                        /*global prompt*/
                        var text = prompt('Change text', $hoveredEl.text());

                        if (text) {
                            vent.trigger('editor.content:change', {
                                text: text,
                                objectType: '.Text'
                            });
                        }
                    });

                    // Trigger hover editable mode
                    vent.trigger(this.highlightEvent, element, 'editable');
                }
            }
        },

        objectType: '.Text',

        action: function () {
            /*global prompt*/
            var text = prompt('Text', ''),
                data = {
                    text: text,
                    objectType: '.Text'
                };
            if (!text) {
                return;
            }
            this.addContent(data);
        },

        dragStart: function (event) {
            event.originalEvent.dataTransfer.setData('div[data-view="column"]:not(:has([data-type]))', '');
            event.originalEvent.dataTransfer.setData('html', '');
        }

    });

});
